%define         srcname        fvwm
%define         cfgname        %{name}-config-mageia
%define         docname        %{name}-doc
%define         fvwmconfdir    %{_sysconfdir}/X11/fvwm2

Name:           fvwm2
Version:        2.7.0
Release:        %mkrel 3
Summary:        The F virtual window manager for the X Window system
License:        GPLv2+
Group:          Graphical desktop/Other

URL:            https://www.fvwm.org/
Source0:        https://github.com/fvwmorg/fvwm/releases/download/%{version}/%{srcname}-%{version}.tar.gz

#vintage logo
Source1:        fvwm2.png
#minimal system-wide config to be installed as system.fvwm2rc
Source2:        system-minimal.fvwm2rc
#minimal configuration file, called from the system-minimal.fvwm2rc
Source3:        fvwm2rc-minimal.mga
# an example file to tune user side configuration
Source5:        user.fvwm2rc

# to get an icon on the xterm button
Source6:        fvwm2_terminal.png
#enhanced config files for mageia default settings
Source7:        system-mageia.fvwm2rc
Source8:        fvwm2rc-extra.mga
Source9:        fvwm2.desktop

Patch0:         fvwm-2.5.26-translucent-menus.diff
# Backported from https://github.com/fvwmorg/fvwm3/pull/683
Patch5:		fvwm-0005-Fix-for-lock-recusion-in-handle_all_expose.patch
# Submitted upstream as https://github.com/fvwmorg/fvwm/pull/100
Patch6:		fvwm-0006-Fixes-for-C99-compatibility.patch
# Submitted upstream as https://github.com/fvwmorg/fvwm/pull/100
Patch7:		fvwm-0007-Fixes-for-C99-compatibility.patch
# Submitted upstream as https://github.com/fvwmorg/fvwm/pull/103
Patch8:		fvwm-0008-Update-FvwmAuto.c.patch

BuildRequires:  flex
BuildRequires:  pkgconfig(x11)
BuildRequires:  pkgconfig(xt)
BuildRequires:  pkgconfig(xft)
BuildRequires:  pkgconfig(xpm)
BuildRequires:  pkgconfig(libpng)
BuildRequires:  pkgconfig(readline)
BuildRequires:  pkgconfig(tinfo)
BuildRequires:  pkgconfig(fribidi)
BuildRequires:  libstroke-devel
BuildRequires:  pkgconfig(librsvg-2.0)
BuildRequires:  pkgconfig(xinerama)
BuildRequires:  pkgconfig(xcursor)
BuildRequires:  xsltproc

# for fvwm-menu-headlines
Requires:       desktop-common-data
# for fvwm-menu-xlock
Requires:       xlockmore
# for doing something
Requires:       xterm
# for iconification and wallpaper
Requires:       xwd
Requires:       imagemagick
Requires:       feh
# for mimeinfo
Requires:       perl-File-MimeInfo
# for compositing (enhancement only)
Recommends:       xcompmgr
Recommends:       transset-df
Recommends:       %{name}-doc

Conflicts:        fvwm3

Requires(post):      update-alternatives
Requires(postun):    update-alternatives
Requires(posttrans): update-alternatives

%description
FVWM2 is an extremely powerful ICCCM-compliant multiple virtual
desktop window manager for the X Window system. The F stands for
whatever you want (Feeble, Fabulous, Famous, Fast, Foobar, Fantastic,
Flexible, F......), but the VWM stands for Virtual Window Manager). It
is designed to minimize memory consumption while being highly
customizable. Development is active and support is excellent. Check it
out!




%package -n %{cfgname}
Summary:        Mageia system-wide configuration for Fvwm2
Group:          Graphical desktop/Other
Requires:       fvwm2
#for button bar
Requires:       wmcalclock
Requires:       wmtop
%ifarch %{ix86} x86_64
Requires:       wmcpufreq
%endif
Requires:       wmforkplop
Requires:       wmhdplop
Requires:       wmbutton
Requires:       wmmoonclock
Requires:       wmsystemtray
# for the menu
Requires:       rxvt-unicode
Recommends:     terminology
# for fvwm-bug
Recommends:     sendmail-command

Requires(post):      update-alternatives
Requires(postun):    update-alternatives

%description -n %{cfgname}
%{summary}.



%package -n %{docname}
Summary:        Documentation files for Fvwm2
Group:          Graphical desktop/Other
Conflicts:      fvwm3-doc

%description -n %{docname}
%{summary}.


%prep
%autosetup -p1 -n %{srcname}-%{version}


%build
autoreconf -vfi
%configure \
    --disable-gtk \
    --libexecdir=%{_libdir}/X11/fvwm2 \
    --sysconfdir=%{fvwmconfdir} \
    --with-imagepath=%{_datadir}/icons

%make_build LOCALEDIR=%{_datadir}/locale localedir=%{_datadir}/locale



%install
%{make_install} LOCALEDIR=%{_datadir}/locale localedir=%{_datadir}/locale

install -D -m644 %{SOURCE1} %{buildroot}%{_iconsdir}/fvwm2.png
install -D -m644 %{SOURCE2} %{buildroot}%{fvwmconfdir}/system-minimal.fvwm2rc
install -D -m644 %{SOURCE3} %{buildroot}%{fvwmconfdir}/fvwm2rc-minimal.mga
install -D -m644 %{SOURCE5} %{buildroot}%{_datadir}/fvwm/user.fvwm2rc

install -D -m644 %{SOURCE6} %{buildroot}%{_iconsdir}/fvwm2_terminal.png
install -D -m644 %{SOURCE7} %{buildroot}%{fvwmconfdir}/system-mageia.fvwm2rc
install -D -m644 %{SOURCE8} %{buildroot}%{fvwmconfdir}/fvwm2rc-extra.mga

install -D -m644 %{SOURCE9} %{buildroot}%{_datadir}/xsessions/fvwm2.desktop

%__rm -f %{buildroot}%{_bindir}/fvwm2
%__mv %{buildroot}%{_bindir}/fvwm %{buildroot}%{_bindir}/fvwm2
%__mv %{buildroot}%{_bindir}/fvwm-config %{buildroot}%{_bindir}/fvwm2-config
%__mv %{buildroot}%{_bindir}/fvwm-convert-2.6 %{buildroot}%{_bindir}/fvwm2-convert-2.6
%__mv %{buildroot}%{_bindir}/fvwm-menu-desktop %{buildroot}%{_bindir}/fvwm2-menu-desktop
%__mv %{buildroot}%{_bindir}/fvwm-menu-directory %{buildroot}%{_bindir}/fvwm2-menu-directory
%__mv %{buildroot}%{_bindir}/fvwm-menu-xlock %{buildroot}%{_bindir}/fvwm2-menu-xlock
%__mv %{buildroot}%{_bindir}/fvwm-perllib %{buildroot}%{_bindir}/fvwm2-perllib
%__mv %{buildroot}%{_bindir}/fvwm-root %{buildroot}%{_bindir}/fvwm2-root
%__mv %{buildroot}%{_bindir}/xpmroot %{buildroot}%{_bindir}/fvwm2-xpmroot


#for fvwm-crystal
pushd %{buildroot}%{_bindir}
ln -s fvwm2 fvwm
popd

%find_lang %{name} --all-name


%files -f %{name}.lang
%doc NEWS COPYING
%config(noreplace) %{fvwmconfdir}/fvwm2rc-minimal.mga
%config(noreplace) %{fvwmconfdir}/system-minimal.fvwm2rc
%{_datadir}/xsessions/fvwm2.desktop
%{_bindir}/*
%{_datadir}/fvwm
%{_libdir}/X11/fvwm2
%{_iconsdir}/fvwm2.png



%post
#if the file has been edited, or so, it is a regular file
#and not a symlink. So we first rename it before calling
#update-alternatives to create the symlink.
if [ -f %{fvwmconfdir}/system.fvwm2rc -a ! -h %{fvwmconfdir}/system.fvwm2rc ]; then
    mv %{fvwmconfdir}/system.fvwm2rc %{fvwmconfdir}/system.fvwm2rc.rpmold
fi
update-alternatives --install %{fvwmconfdir}/system.fvwm2rc fvwm2-config \
                    %{fvwmconfdir}/system-minimal.fvwm2rc 10

%postun
#uninstall only
if [ $1 -eq 0 ]; then
   update-alternatives --remove fvwm2-config %{fvwmconfdir}/system-minimal.fvwm2rc
fi

%posttrans
#old releases had system.fvwm2rc as file packaged in, so our symlink
#will be removed if one upgrade from those.
if ! [ -h %{fvwmconfdir}/system.fvwm2rc ]; then
   update-alternatives --install %{fvwmconfdir}/system.fvwm2rc fvwm2-config \
                    %{fvwmconfdir}/system-minimal.fvwm2rc 10
fi

# (ovitters) In posttrans, $1 is always equal to 1, even in the upgrade case.
# So just run this always:
if [ -e %{_datadir}/xsessions/09Fvwm2.desktop ]; then
	rm -rf %{_datadir}/xsessions/09Fvwm2.desktop
fi
if [ -e %{_sysconfdir}/X11/dm/Sessions/09Fvwm2.desktop ]; then
	rm -rf %{_sysconfdir}/X11/dm/Sessions/09Fvwm2.desktop
fi



%files -n %{cfgname}
%config(noreplace) %{fvwmconfdir}/fvwm2rc-extra.mga
%config(noreplace) %{fvwmconfdir}/system-mageia.fvwm2rc
%{_iconsdir}/fvwm2_terminal.png


%post -n %{cfgname}
if [ -f %{fvwmconfdir}/system.fvwm2rc -a ! -h %{fvwmconfdir}/system.fvwm2rc ]; then
    mv %{fvwmconfdir}/system.fvwm2rc %{fvwmconfdir}/system.fvwm2rc.rpmold
fi
update-alternatives --install %{fvwmconfdir}/system.fvwm2rc fvwm2-config \
                    %{fvwmconfdir}/system-mageia.fvwm2rc 11

%postun -n %{cfgname}
if [ $1 -eq 0 ]; then
   update-alternatives --remove fvwm2-config %{fvwmconfdir}/system-mageia.fvwm2rc
fi


%files -n %{docname}
%{_mandir}/man1/*


%changelog
* Mon Jun 30 2025 umeabot <umeabot> 2.7.0-3.mga10
+ Revision: 2229701
- Mageia 10 Mass Rebuild

* Wed Oct 30 2024 daviddavid <daviddavid> 2.7.0-2.mga10
+ Revision: 2111772
- backport upstream PRs to fix build

* Sun Mar 05 2023 eatdirt <eatdirt> 2.7.0-1.mga9
+ Revision: 1947672
- Update to bug fix release 2.7.0

* Wed Mar 30 2022 umeabot <umeabot> 2.6.9-6.mga9
+ Revision: 1835615
- Mageia 9 Mass Rebuild

* Thu Aug 26 2021 eatdirt <eatdirt> 2.6.9-5.mga9
+ Revision: 1742667
- Add conflicts with fvwm3

* Fri Sep 04 2020 eatdirt <eatdirt> 2.6.9-4.mga8
+ Revision: 1622218
- Fix symlink and put doc in a separate package
+ ovitters <ovitters>
- fix usage of  in posttrans
+ pterjan <pterjan>
- Remove usage of obsolete macros (https://github.com/rpm-software-management/rpm/issues/1211)

* Tue Feb 18 2020 umeabot <umeabot> 2.6.9-3.mga8
+ Revision: 1542092
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Sat Jan 04 2020 luigiwalser <luigiwalser> 2.6.9-2.mga8
+ Revision: 1475946
- rebuild for readline

* Sat Sep 07 2019 daviddavid <daviddavid> 2.6.9-1.mga8
+ Revision: 1438067
- new version: 2.6.9
- drop Recommends to retroterm (it pull a ton of Qt5 dependencies)

* Mon Sep 02 2019 eatdirt <eatdirt> 2.6.8-4.mga8
+ Revision: 1436346
- Add Recommends to retroterm

* Sat Oct 20 2018 pterjan <pterjan> 2.6.8-3.mga7
+ Revision: 1322642
- Only require wmcpufreq on the architectures where it exists

* Fri Oct 05 2018 umeabot <umeabot> 2.6.8-2.mga7
+ Revision: 1317784
- Mageia 7 Mass Rebuild

* Sun Jun 24 2018 eatdirt <eatdirt> 2.6.8-1.mga7
+ Revision: 1239485
- Upgrade to version 2.6.8

* Thu Jan 18 2018 shlomif <shlomif> 2.6.7-4.mga7
+ Revision: 1194409
- Rebuild for new imagemagick

* Tue Jan 02 2018 wally <wally> 2.6.7-3.mga7
+ Revision: 1189429
- rebuild for new readline

* Fri Feb 24 2017 wally <wally> 2.6.7-2.mga6
+ Revision: 1087700
- drop obsolete wmsession.d files
- remove generated xsessions .desktop files on update
- rename xsession .desktop file

* Thu Dec 01 2016 eatdirt <eatdirt> 2.6.7-1.mga6
+ Revision: 1071472
- Upgrade to latest stable version 2.6.7

* Thu Sep 15 2016 eatdirt <eatdirt> 2.6.6-2.mga6
+ Revision: 1053109
- Add desktop file for sddm

* Thu Jun 23 2016 eatdirt <eatdirt> 2.6.6-1.mga6
+ Revision: 1037295
- Upgrade to version 2.6.6

* Tue Mar 08 2016 eatdirt <eatdirt> 2.6.5-15.mga6
+ Revision: 987639
- Enhancing configuration settings for fvwm2-config-mageia

* Tue Feb 09 2016 umeabot <umeabot> 2.6.5-14.mga6
+ Revision: 952275
- Mageia 6 Mass Rebuild

* Fri Feb 06 2015 eatdirt <eatdirt> 2.6.5-13.mga5
+ Revision: 813700
- Fix fvwm-crystal missing fvwm binary (symlink to fvwm2)

* Wed Oct 15 2014 umeabot <umeabot> 2.6.5-12.mga5
+ Revision: 746020
- Second Mageia 5 Mass Rebuild

* Thu Sep 25 2014 eatdirt <eatdirt> 2.6.5-11.mga5
+ Revision: 724730
- Add terminology to desktop menu

* Tue Sep 16 2014 umeabot <umeabot> 2.6.5-10.mga5
+ Revision: 679387
- Mageia 5 Mass Rebuild
+ tv <tv>
- s/uggests:/Recommends:/

* Fri May 23 2014 eatdirt <eatdirt> 2.6.5-9.mga5
+ Revision: 625089
- Rebuild for old age, tuning configuration files

* Mon Oct 21 2013 umeabot <umeabot> 2.6.5-8.mga4
+ Revision: 540010
- Mageia 4 Mass Rebuild

* Tue Oct 08 2013 colin <colin> 2.6.5-7.mga4
+ Revision: 493209
- Rebuild against ncurse's libtinfo rather than libtermcap

* Mon Jun 03 2013 fwang <fwang> 2.6.5-6.mga4
+ Revision: 435902
- rebuild for new libpng

* Sat Jun 01 2013 eatdirt <eatdirt> 2.6.5-5.mga4
+ Revision: 434278
- Enhancements for better integration with other packages (as razorqt)
- split into fvwm2 (minimal config) and fvwm2-config-mageia (add menus + buttons)

* Fri Jan 11 2013 umeabot <umeabot> 2.6.5-4.mga3
+ Revision: 351004
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Wed Jan 09 2013 eatdirt <eatdirt> 2.6.5-3.mga3
+ Revision: 344094
- Fix wallpaper size, missing button icon

* Fri Oct 26 2012 malo <malo> 2.6.5-2.mga3
+ Revision: 310314
- update RPM group

* Wed Aug 22 2012 eatdirt <eatdirt> 2.6.5-1.mga3
+ Revision: 283139
- Upgrade to 2.6.5, default configuration enhanced

* Sun Feb 05 2012 eatdirt <eatdirt> 2.6.4-1.mga2
+ Revision: 204824
- Upgrade to 2.6.4
  System-wide config file cleaned
  Added an user config file example

* Fri Oct 07 2011 eatdirt <eatdirt> 2.6.3-1.mga2
+ Revision: 152793
- upgrade to 2.6.3

* Wed Sep 14 2011 eatdirt <eatdirt> 2.6.2-1.mga2
+ Revision: 143594
- upgrade to 2.6.2

* Sun May 15 2011 pterjan <pterjan> 2.6.1-2.mga1
+ Revision: 98982
- Rebuild for fixed find-requires

* Tue Apr 19 2011 eatdirt <eatdirt> 2.6.1-1.mga1
+ Revision: 88135
- new version 2.6.1

* Wed Apr 13 2011 obgr_seneca <obgr_seneca> 2.5.31-1.mga1
+ Revision: 84416
- imported package fvwm2


* Fri Apr 12 2011 Chris Ringeval <dirteat@gmail.com> 2.5.31-1mga1
- Upgraded to 2.5.31
- Configuration file modified (configuration replaced by fvwm2rc.example)
- Added dependencies to xwd
- Suggests xcompmgr, transset for simple compositing
- Removed dependency to rplay
- Python xdg menu generation replaced by PipeRead (fvwm2rc.example)
- Old patches removed

* Fri Sep 11 2009 Thierry Vignaud <tvignaud@mandriva.com> 2.5.26-2mdv2010.0
+ Revision: 437611
- rebuild

* Sat Apr 04 2009 Funda Wang <fundawang@mandriva.org> 2.5.26-1mdv2009.1
+ Revision: 363986
- fix str fmt
- rediff translucent menu patch

  + Oden Eriksson <oeriksson@mandriva.com>
    - lowercase ImageMagick

* Wed Aug 06 2008 Adam Williamson <awilliamson@mandriva.org> 2.5.26-1mdv2009.0
+ Revision: 264127
- clean up a couple of variables
- buildrequires librsvg-devel and libxinerama-devel to enable these functions
  (thanks Fedora)
- drop the GTK+ 1.2 buildrequire (and hence the old and useless GTK+ 1.2 module)
- add several requires (thanks Fedora)
- new license policy
- sync patches with Fedora: add xdg-open.patch, mimeopen.patch and menu-generate.patch
- update to latest translucent-menus.diff from Gentoo
- add fvwm-xdg-menu.py as a source (from Fedora, needed for a Fedora patch)
- reorder sources
- fix indentations
- get rid of some bogus requires and provides (thanks Fedora)
- remove some unnecessary %%defines
- new release 2.5.26

* Thu Jul 24 2008 Thierry Vignaud <tvignaud@mandriva.com> 2.5.21-4mdv2009.0
+ Revision: 245567
- rebuild

  + Pixel <pixel@mandriva.com>
    - rpm filetriggers deprecates update_menus/update_scrollkeeper/update_mime_database/update_icon_cache/update_desktop_database/post_install_gconf_schemas

* Thu Mar 13 2008 Andreas Hasenack <andreas@mandriva.com> 2.5.21-2mdv2008.1
+ Revision: 187612
- rebuild for 2008.1

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request

* Tue May 22 2007 Guillaume Rousse <guillomovitch@mandriva.org> 2.5.21-1mdv2008.0
+ Revision: 29904
- new version


* Thu Jan 18 2007 Guillaume Rousse <guillomovitch@mandriva.org> 2.5.18-4mdv2007.0
+ Revision: 110130
- revert to previous setup, with distinct configuration and menu files included from main configuration file

* Mon Dec 11 2006 Guillaume Rousse <guillomovitch@mandriva.org> 2.5.18-3mdv2007.1
+ Revision: 94775
- bump release
- buildrequires libxft-devel

* Fri Dec 08 2006 Guillaume Rousse <guillomovitch@mandriva.org> 2.5.18-2mdv2007.1
+ Revision: 92250
- return of the translucent menu patch

* Wed Nov 29 2006 Guillaume Rousse <guillomovitch@mandriva.org> 2.5.18-1mdv2007.1
+ Revision: 88337
- new version
  drop transclucy patch (merged upstream)

* Thu Nov 16 2006 Guillaume Rousse <guillomovitch@mandriva.org> 2.5.10-9mdv2007.1
+ Revision: 84723
- new release
- fix buildrequires name
- bump release
- fix buildrequires
- bump release
- removed unused macros
- unused anymore
- move icons into a distinct source package, as they are distributed separatly
- fix menus
- no more need for the cursor hack
- add icon in wmsession script
- switch to new menu conversion system
- no need for menu entries
- patch is now uncompressed
- use a single configuration file, as twm
- uncompressed all additional sources
- icons are now generated with convert
- revert previous change, seems this menu template is needed after all
- don't ship default menu, let's use standard menu system
- unused anymore
- convert old menu to new xdg menu
  fix old menu to use png icons
  use fvwm2 icons set
- drop old obsoletes
- %%{1}mdv2007.1
- spec cleanup
- fix prefix
- fix buildrequires
- Import fvwm2

* Thu Jan 20 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 2.5.10-5mdk
- rebuild for new readline

* Sun Jul 25 2004 Olivier Thauvin <thauvin@aerov.jussieu.fr> 2.5.10-4mdk
- From Philippe Reynes <trem@zarb.org> 
    - fix the compilation problem

* Sun Jun 13 2004 Olivier Thauvin <thauvin@aerov.jussieu.fr> 2.5.10-3mdk
- Fix missing binary (Thanks Gregoire Favre <Gregoire.Favre@freesurf.ch>)

* Fri Jun 11 2004 Olivier Thauvin <thauvin@aerov.jussieu.fr> 2.5.10-2mdk
- apply transparency patch0 (ask by Yves Brissaud)

* Fri Jun 11 2004 Olivier Thauvin <thauvin@aerov.jussieu.fr> 2.5.10-1mdk
- 2.5.10

* Fri Apr 23 2004 Olivier Thauvin <thauvin@aerov.jussieu.fr> 2.4.18-1mdk
- 2.4.18
